
#to do: Henchmen availability (State=1)
#       Count of Items in inventory
#       HenchStore?
#       fix what's wrong with Journal?


use strict;
use Win32::GUI('WS_VSCROLL');
use Bioware::GFF 0.71;
use Bioware::TLK 0.04;
use Bioware::TwoDA 0.23;
use Bioware::RIM;

use Win32::TieRegistry;
use Win32::FileOp;
use Win32::API;
my $version='0.5';  # Fixed a little bug with the StyleLevel (+1 to it)
                    # Added Henchmen selection/availability

#0.3';  #Added Weapons, Plot Items, Flyer Improvements, Techniques, Amulet, Gems nodes
                    #Also added ability to Add/Remove Styles and the above elements  
#0.2; #added appearance label support as 2dalist and fixed that treatment in btnApply

#0.1 - 29-Jul-2007: new

use Win32::GUI::DIBitmap;
my $icon=Win32::GUI::Icon->new('jse.ico');
my $icon2=Win32::GUI::Icon->new('jselog.ico');
my $msgbox=Win32::API->new('user32','MessageBoxA','NPPN','N');
my $mw = Win32::GUI::Window->new(
  -name => 'Main',
  -text => 'JSE - Jade Empire Savegame Editor v'.$version,
  -width => 800,
  -height => 600,
  -center => 1,
  -dialogui=>1,
  #-background=>[156,166,205]
);

$mw->SetIcon($icon);
my $hbitmap=Win32::GUI::Bitmap->new('jse.bmp');
#my $dib = Win32::GUI::DIBitmap->newFromFile('jse.jpg');
#my $hbitmap = $dib->ConvertToBitmap();
#undef $dib;

my $lblLogo=$mw->AddLabel(
                          -bitmap=>$hbitmap,
                          -size=>[239,130],
                          -pos=>[531,20]
                         );

my $courierfont=Win32::GUI::Font->new(-family=>'Courier New',
                                      -size=>8,
                                      );

my $lw=Win32::GUI::Window->new(
                               -name=>'LogWindow',
                               -text=>'Jade Empire Savegame Editor Log Window',
                               -width=>600,
                               -height=>600,
                               -center=>1,
                               -dialogui=>1
                              );
$lw->SetIcon($icon2);
my $lstLog=$lw->AddTextfield(-size=>[580,570],
                           -pos=>[0,0],
                           -font=>$courierfont,
                           -multiline=>1,
                           -autovscroll   => 1,
                           -pushstyle=>WS_VSCROLL,
                           -name=>'Log');
LogIt("Begin");
my %tree_paths_to_nodes;  # node number -> fullpath using # as separator
my %tree_nodes_to_paths;
my %tree_data;
my $jade_path;

my $global_suppress_next_logit;

my $tree=$mw->AddTreeView(
                                   -left=>10,
                                   -top=>10,
                                   -width=>500,
                                   -height=>560,
                                   -buttons => 1,
                                   -lines=>1,
                                   -name=>'tree',
                                   
                                  );
my $lblPos1=[516,295+40];
my $lblPos2=[516,201+40];

$mw->AddLabel( -pos =>$lblPos1,
                        #-left=>616,
                        #-top=>295,
                        -height=>15,
                        -width=>161,
                        #-text=>'Field',
                        -name=>'lblValue',
                       );
$mw->AddTextfield(
                  -left=>516,
                  -top=>312+40,
                  -height=>25,
                  -width=>161,
                  -name=>'txtValue'
                 );
$mw->AddButton(-pos=>[516,480],
               -size=>[120,38],
               -text=>'Apply',
               -name=>'btnApply',
               -disabled=>1,
               
              );
$mw->AddButton(
               -pos=>[650,480],
               -size=>[120,38],
               -text=>'Save To Disk',
               -name=>'btnSave',
               -disabled=>1,
              );

$mw->AddButton(
               -pos=>[516,525],
               -size=>[90,28],
               -text=>'View Log',
               -name=>'btnLog',
              );
$mw->AddButton(
               -pos=>[650+120-90,525],
               -size=>[90,28],
               -text=>'Remove',
               -disabled=>1,
               -name=>'btnRemove'
              );
for my $optix(0..7) {
    $mw->AddRadioButton(
                        -pos=>[580,257+($optix*20)],
                        -size=>[261,25],
                        -name=>'opt'.$optix,
                        -visible=>0,
                       );
}
$mw->AddListbox(
               -left=>516,
               -top=>257,
               -height=>134,
               -width=>261,
               -name=>'lstValues',
               -visible=>0,
               -pushstyle=>WS_VSCROLL
               );
$mw->AddTextfield(
                  -left=>516,
                  -top=>257+124,
                  -height=>95,
                  -width=>261,
                  -background=>[200,200,200],
                  -multiline=>1,
                  -disabled=>0,
                  -visible=>0,
                  -pushstyle=>WS_VSCROLL,
                  -name=>'txtDesc',
                 );
for my $i (0..2) {
    
    my $slider=$mw->AddSlider(
                   -pos=>[516,220+($i*80)],
                   -size=>[261,30],
                   -name=>'Slider'.$i,
                   -visible=>0,
                  );
    $slider->SetTicFreq(1);
    $slider->SetRange(0,5);
    $slider->SetLineSize(1);
    
    $mw->AddLabel(-pos=>[$slider->Left(),$slider->Top()-18],
                  -size=>[$slider->Width(),14],
                  -text=>"Slider $i",
                  -name=>"lblSlider$i",
                  -visible=>0);
    
    $mw->AddLabel(-pos=>[$slider->Left()-4+(2*($slider->GetTicPos(0))-$slider->GetTicPos(1)),$slider->Top()+$slider->Height()+5],
                  -size=>[10,12],
                  -text=>'0',
                  -name=>'ticSlider'.$i.'0',
                  -visible=>0
                 );
    for my $j (1..4) {
        $mw->AddLabel(-pos=>[$slider->Left()+$slider->GetTicPos($j-1)-2,$slider->Top()+$slider->Height()+5],
                  -size=>[10,12],
                  -text=>$j,
                  -name=>'ticSlider'.$i.$j,
                  -visible=>0
                     );
    }
    $mw->AddLabel(-pos=>[($slider->Left()+(2*$slider->GetTicPos(3))-2)-$slider->GetTicPos(2),$slider->Top()+$slider->Height()+5],
                  -size=>[10,12],
                  -text=>'5',
                  -visible=>0,
                  -name=>'ticSlider'.$i.'5',
                 );
}



                

eval { my  $jade_key= new Win32::TieRegistry "LMachine/Software/Bioware/Jade Empire",             #read registry
          {Access=>Win32::TieRegistry::KEY_READ, Delimiter=>"/"};
          $jade_path= $jade_key->GetValue("Path") };
if ($@) {
    exit unless ($jade_path=BrowseForFolder('Locate Jade Empire installation directory'));
    if (!(-e $jade_path."/JadeEmpire.exe.exe")) {msg("JadeEmpire.exe not found. Exiting.","JadeEmpire.exe not found"); exit;}
}
LogIt("Jade Empire path read from registry");
LogIt(" $jade_path");
# read saves directories
unless (opendir SAVDIR, $jade_path."/save") {                                        #saves directory not found
    msg('Could not find save directory for Jade Empire. Exiting.','Saves not found');
    exit;
}
add_new_treeitem('#','Jade Empire Save Games');
my @savedirs=grep { !(/\\\.+$/) && -d } map {"$jade_path\\save\\$_"} readdir(SAVDIR);    #read all directories in saves dir
close SAVDIR;
for (@savedirs) {
    /\\.*\\(.+?)$/;
    my $dir=$1;
    add_new_treeitem('#'.$dir,$dir);
    add_new_treeitem('#'.$dir.'#','.');
}

my %twodas;
my %itemtype_to_filter=qw(4 gems
                          6 plot_items 
                          5 weapons
                          7 mgweapons 
                          8 improve );
my %itemtype_to_2da=qw(4 gems
                       5 weapons
                       6 plot_items 
                       7 mgweapons 
                       8 improvements );
my %itemtype_to_display=(4=>'Gems',
                         5=>'Weapons',
                         6=>'Plot Items',
                         7=>'Flyer Improvements',
                         8=>'Techniques');
my %itemtype_to_letter=qw(5 w 6 p 7 f 8 t);
my @henchs=('Henpecked Ho',
            'Kang',
            'Sky',
            'Black Whirlwind',
            'Dawn Star',
            'Sagacious Zu',
            'Silk Fox',
            'Chai Ka',
            'Ya Zhen',
            'Death\'s Hand',
            'Wild Flower',
            'The Aboot',
            'Zin Bu the Magic Abacus');
my @availopt=('NO','YES');
                          
initialize_2das();

$mw->tree->Expand($tree_paths_to_nodes{'#'});
$mw->Show();


Win32::GUI::Dialog();


sub add_new_treeitem{
    my $path=shift;
    my $string=shift;
    my $data=shift;
    
    
    my $new_node;
    if ($path eq '#') { #root
        $new_node=$mw->tree->InsertItem(-text=>$string);
    }
    elsif ($path =~ /(#.*)#/) {
        my $parent_path=$1;
        
        my $parent_node=$tree_paths_to_nodes{$parent_path};
        $new_node=$mw->tree->InsertItem(-parent=>$parent_node,
                                       -text=>$string,
                                      );
    }
    elsif ($path=~/#(.*)/) {
        my $parent_path='#';
        my $parent_node=$tree_paths_to_nodes{$parent_path};
        $new_node=$mw->tree->InsertItem(-parent=>$parent_node,
                                       -text=>$string,
                                      );
    }
    $tree_paths_to_nodes{$path}=$new_node;
    %tree_nodes_to_paths=reverse %tree_paths_to_nodes;
    $tree_data{$path}=$data;
    
}
sub btnLog_Click {
    Win32::GUI::Show($lw);
}
sub LogWindow_Terminate {
    Win32::GUI::Hide($lw);
    return 0;
}
sub LogIt {
    my $logmsg=shift;
    
    $lw->Log->Append("$logmsg\r\n") unless $global_suppress_next_logit;
    $global_suppress_next_logit=0;
}
sub msg {
    
#Private Const MB_ABORTRETRYIGNORE = &H2&
#Private Const MB_DEFBUTTON1 = &H0&
#Private Const MB_DEFBUTTON2 = &H100&
#Private Const MB_DEFBUTTON3 = &H200&
#Private Const MB_ICONEXCLAMATION = &H30&
#Private Const MB_ICONHAND = &H10&
#Private Const MB_ICONQUESTION = &H20&
#Private Const MB_OK = &H0&
#Private Const MB_OKCANCEL = &H1&
#Private Const MB_RETRYCANCEL = &H5&
#Private Const MB_YESNO = &H4&
#Private Const MB_YESNOCANCEL = &H3&

my %responses = qw (1 ok
                    2 cancel
                    3 abort
                    4 retry
                    5 ignore
                    6 yes
                    7 no);
    my $msg=shift;
    my $title=shift;
    my $btns=shift;
    my $hwnd=shift;
    
    unless ($hwnd) { $hwnd=$mw->{-handle} }
    
    my $response=$msgbox->Call($hwnd,$msg,$title,$btns);
    if (exists $responses{$response}) {
        return $responses{$response};
    }
    else {
        return "unknown";
    }
}
sub tree_Expanding {
  my $node=shift;
  my @branches=split /#/, $tree_nodes_to_paths{$node};
  my $child_node_path=$tree_nodes_to_paths{$node}.'#';
  LogIt("Expanding $tree_nodes_to_paths{$node}");
  if ((scalar @branches == 2) && (exists $tree_paths_to_nodes{$child_node_path})) {
      my $child_node=$tree_paths_to_nodes{$child_node_path};
      $mw->tree->DeleteItem($child_node);
      delete $tree_paths_to_nodes{$child_node_path};
      %tree_nodes_to_paths=reverse %tree_paths_to_nodes;
      Populate_Level1($tree_nodes_to_paths{$node});
  }
  return 1;
}
sub Populate_Level1 {
    my $treeitem=shift;
    my $gamedir=(split /#/,$treeitem)[1];
    LogIt("Reading $jade_path\\save\\$gamedir\\save.sac");
    my $gff=read_sac("$jade_path\\save\\$gamedir\\save.sac");
    if (!defined($gff)) {
        LogIt("***Failed to read!");
        return; }
    $tree_data{$treeitem}=$gff;  #save the gff
    LogIt("Populating tree branches...");
    
    
    
    my $playercreature_struct_ix=$gff->{Main}->fbl('PlayerCreature');
    my $playercreature_struct=$gff->{Main}{Fields}[$playercreature_struct_ix]{Value};
    
    my %fieldnames=('1'=>{'field'=>'FirstName','display'=>'Name'},
                    '2'=>{'field'=>'CurrentXP','display'=>'Current XP'}
                   );
                    
    for my $fn(1..2) {
        
        my $ix=$playercreature_struct->fbl($fieldnames{$fn}{'field'});
        my $val=$playercreature_struct->{Fields}[$ix]{Value};
        add_new_treeitem($treeitem.'#'.$fieldnames{$fn}{'field'},"$fieldnames{$fn}{'display'}: $val",$playercreature_struct->{Fields}[$ix]);
    }
    
    my $stats_ix=$playercreature_struct->fbl('Stats');
    my $stats_struct=$playercreature_struct->{Fields}[$stats_ix]{Value};
    %fieldnames=('1'=>{'field'=>'Alignment','display'=>'Alignment'},
                '2'=>{'field'=>'Appearance','display'=>'Appearance'},
                '3'=>{'field'=>'Gold','display'=>'Silver'},
                
                '4'=>{'field'=>'Body','display'=>'Body'},
                '5'=>{'field'=>'Spirit','display'=>'Spirit'},
                '6'=>{'field'=>'Mind','display'=>'Mind'},

                '7'=>{'field'=>'Health','display'=>'Health'},
                '8'=>{'field'=>'HealthBase','display'=>'Health Max'},
                '9'=>{'field'=>'Chi','display'=>'Chi'},
                '10'=>{'field'=>'ChiBase','display'=>'Chi Max'},
                );
    
    
    for my $fn(1..10) {
        my $ix=$stats_struct->fbl($fieldnames{$fn}{'field'});
        my $val=$stats_struct->{Fields}[$ix]{Value};
        if ($fn==2) {
            my $appearance_label=$twodas{appearance}[$val]{LABEL};
            my $data= { 'type'=>'2dalist',
                        '2daname' => 'appearance',
                        '2dafield' => 'LABEL',
                        'appendlabel' => 0,
                        'gff' => $stats_struct->{Fields}[$ix],
                        'gff2' => $playercreature_struct->{Fields}[$playercreature_struct->fbl('PlayerOrigApp')],
                        'is_stringref'=>0,
                      };
            add_new_treeitem($treeitem.'#'.$fieldnames{$fn}{'field'},"$fieldnames{$fn}{'display'}: $appearance_label",$data);
        }
        else {
            add_new_treeitem($treeitem.'#'.$fieldnames{$fn}{'field'},"$fieldnames{$fn}{'display'}: $val",$stats_struct->{Fields}[$ix]);
        }
    }
    
    
    my $focus_struct=$stats_struct->{Fields}[$stats_struct->fbl('Focus')]{Value};
    
    %fieldnames=('1'=>{'field'=>'STAT_CUR','display'=>'Focus'},
                 '2'=>{'field'=>'STAT_MAX','display'=>'Focus Max'}
                );
                    
    for my $fn(1..2) {
        my $ix=$focus_struct->fbl($fieldnames{$fn}{'field'});
        my $val=$focus_struct->{Fields}[$ix]{Value};
        add_new_treeitem($treeitem.'#'.$fieldnames{$fn}{'field'},"$fieldnames{$fn}{'display'}: $val",$focus_struct->{Fields}[$ix]);
    }
    
    %fieldnames=('1'=>{'field'=>'Charm','display'=>'Charm Adjustment','type'=>FIELD_INT},
                '2'=>{'field'=>'Intimidate','display'=>'Intimidate Adjustment','type'=>FIELD_INT},
                '3'=>{'field'=>'Intuition','display'=>'Intuition Adjustment','type'=>FIELD_INT},
                #'4'=>{'field'=>'CurrentStyleId','display'=>'Current Style ID','type'=>FIELD_DWORD},
                );
    for my $fn(1..3) {
        my $ix=$stats_struct->fbl($fieldnames{$fn}{'field'});
        if (!defined($ix)) {
            $stats_struct->createField('Type'=>$fieldnames{$fn}{type},'Label'=>$fieldnames{$fn}{field},'Value'=>0);
            my $fieldsref=$stats_struct->{Fields};
            $ix=(scalar @$fieldsref) - 1;
        }
        my $val=$stats_struct->{Fields}[$ix]{Value};
        #if ($fn==4) {
        #    my $stylename_ref=$twodas{stylesuperlist}[$val]{NameRef};
        #    my $stylename=string_from_resref($jade_path,$stylename_ref);
        #    my $data= { 'type'=>'2dalist',
        #                '2daname' => 'stylesuperlist',
        #                '2dafield' => 'NameRef',
        #                'appendlabel' => 1,
        #                'gff' => $stats_struct->{Fields}[$ix],
        #                'is_stringref'=>1,
        #                'show_desc'=>1,
        #                'descfield'=>'DescRef'
        #              };
        #    add_new_treeitem($treeitem.'#'.$fieldnames{$fn}{'field'},"$fieldnames{$fn}{'display'}: $stylename",$data);
        #}
        #else {
        add_new_treeitem($treeitem.'#'.$fieldnames{$fn}{'field'},"$fieldnames{$fn}{'display'}: $val",$stats_struct->{Fields}[$ix]);
        #}
    }

    #Followers...
    add_new_treeitem($treeitem.'#Henchmen',"Henchmen",undef);
    my $henchmen_ix=$playercreature_struct->fbl('Henchmen');
    my $henchmen_struct=$playercreature_struct->{Fields}[$henchmen_ix]{Value};
    my $henchmen_selected_ix=$henchmen_struct->fbl('Selected');
    my $henchmen_selected_value=$henchmen_struct->{Fields}[$henchmen_selected_ix]{Value};
    my $henchdata={'type'=>'list',
                   'list'=>\@henchs,
                   'gff'=>$henchmen_struct->{Fields}[$henchmen_selected_ix],
                   'show_desc'=>0};
    my $hench_current=$henchs[$henchmen_selected_value];
    add_new_treeitem($treeitem.'#Henchmen#Selected','Currently Selected: '.
                     $hench_current,
                     $henchdata);
    add_new_treeitem($treeitem.'#Henchmen#Avail',"Availability",undef);
    my $henchmen_list=$henchmen_struct->{Fields}[$henchmen_struct->fbl('HenchList')];

    
    for my $i (0..12) {
        my $hench_struct=$henchmen_list->{Value}[$i];
        my $hench_state_ix;
        if (!(defined ($hench_state_ix=$hench_struct->fbl('State')))) {
            $hench_struct->createField('Type'=>FIELD_BYTE,'Label'=>'State','Value'=>0);
            $hench_state_ix=$hench_struct->fbl('State');
        }
        my $hench_state=$hench_struct->{Fields}[$hench_state_ix]{Value};
        add_new_treeitem($treeitem.'#Henchmen#Avail#'.$i,"$henchs[$i]: $availopt[$hench_state]",{'type'=>'optionlist',
                                                                                      'options'=>\@availopt,  #'2','3','4','5','6','7'],
                                                                                      'gff'=>$hench_struct->{Fields}[$hench_state_ix]});
    }
    
    
    #Amulet...
    add_new_treeitem($treeitem.'#Amulet',"Amulet",undef);
    my $amulet_ix=$playercreature_struct->fbl('Amulet');
    my $amulet_struct=$playercreature_struct->{Fields}[$amulet_ix]{Value};
    my $amulet_typeix;
    if (!defined($amulet_typeix=$amulet_struct->fbl('Type'))) {
        $amulet_struct->createField('Type'=>FIELD_BYTE,'Label'=>'Type','Value'=>0);
        $amulet_typeix=$amulet_struct->fbl('Type');
    }
    add_new_treeitem($treeitem.'#Amulet#Type',"Upgrade Level: ".$amulet_struct->{Fields}[$amulet_typeix]{Value},$amulet_struct->{Fields}[$amulet_typeix]);
    my $amulet_opengemslistix=$amulet_struct->fbl('OpenGemsList');
    my $amulet_gemslist=$amulet_struct->{Fields}[$amulet_opengemslistix];
    for my $i(0..6) {
        my $amulet_gem_struct=$amulet_gemslist->{Value}[$i];
        my $amulet_gem_name="(none)";
        if ((ref $amulet_gem_struct->{Fields}) eq 'Bioware::GFF::Field') {
            my $amulet_gem_substruct=$amulet_gem_struct->{Fields}{Value};
            my $amulet_gem_id_ix=$amulet_gem_substruct->fbl('ItemID');
            my $amulet_gem_id=$amulet_gem_substruct->{Fields}[$amulet_gem_id_ix]{Value};
            my $amulet_gem_strref=$twodas{items}[$amulet_gem_id]{'STRREF_NAME'};
            $amulet_gem_name=string_from_resref($jade_path,$amulet_gem_strref);
        }
        my $data= { 'type'=>'2dalist',
                        '2daname' => 'items',
                        '2dafield' => 'STRREF_NAME',
                        'appendlabel' => 0,
                        'gff' => $amulet_gemslist,
                        'is_stringref'=>1,
                        'show_desc'=>1,
                        'descfield'=>'STRREF_DESC',
                        'filterfield'=>'TYPE',
                        'filtervalue'=>'gems',
                        'gff_is_list'=>1,
                        'gff_list_ix'=>$i,

                      };
            
        add_new_treeitem($treeitem."#Amulet#Gems".$i,"Slot ".($i+1).": $amulet_gem_name",$data);

    }
    
    
    
    
    #Gem List...
    my $gems_ix;
    
        #no gem list?  we can't have that...
    if (!defined($gems_ix=$playercreature_struct->fbl('Gems'))) {
        $playercreature_struct->createField('Type'=>FIELD_LIST,'Label'=>'Gems','Value'=>[]);
        $gems_ix=$playercreature_struct->fbl('Gems');
    }
    #if (defined($gems_ix=$playercreature_struct->fbl('Gems'))) {
        add_new_treeitem($treeitem.'#Gems',"Spare Gems",{'type'=>'addgem','gff'=>$playercreature_struct->{Fields}[$gems_ix],'2daname'=>'items','filtertype'=>4});
        my $gems_struct_arr_ref=$playercreature_struct->{Fields}[$gems_ix]{Value};
        if ((ref $gems_struct_arr_ref)=~/Bioware/) {
            $gems_struct_arr_ref=[$gems_struct_arr_ref];
        }
        my $i=0;
        my %h;
        for my $gem_struct (@$gems_struct_arr_ref) {
            my $gem_substruct=$gem_struct->{Fields}{Value};
            my $gem_id_ix=$gem_substruct->fbl('ItemID');
            my $gem_id=$gem_substruct->{Fields}[$gem_id_ix]{Value};
            my $gem_strref=$twodas{items}[$gem_id]{'STRREF_NAME'};
            my $gem_name=string_from_resref($jade_path,$gem_strref);

            
            my $data= { 'type'=>'2dalist',
                        '2daname' => 'items',
                        '2dafield' => 'STRREF_NAME',
                        'appendlabel' => 0,
                        'gff' => $playercreature_struct->{Fields}[$gems_ix],
                        'is_stringref'=>1,
                        'show_desc'=>1,
                        'descfield'=>'STRREF_DESC',
                        'filterfield'=>'TYPE',
                        'filtervalue'=>'gems',
                        'gff_is_list'=>1,
                        'gff_list_ix'=>$i,
                      };
            
            $h{$gem_name.$i}=[$treeitem."#Gems#".$i,$gem_name,$data];
            #add_new_treeitem($treeitem."#Gems#".$i,$gem_name,$data);
            $i++;
        }
        for my $k (sort keys %h) {
            add_new_treeitem($h{$k}->[0],$h{$k}->[1],$h{$k}->[2]);
        }
            
    #}
    
    #Item List...
    my $itemlist_ix;
    if (defined($itemlist_ix=$playercreature_struct->fbl('ItemList'))) {
        my $itemlist=$playercreature_struct->{Fields}[$itemlist_ix]{Value};
        #create parent nodes where items can be added...
        for my $i(5..8) {
            add_new_treeitem($treeitem.'#ItemList_'.$itemtype_to_letter{$i},$itemtype_to_display{$i},{'type'=>'additem', 'gff'=>$playercreature_struct->{Fields}[$itemlist_ix],'filtertype'=>$i,'2daname'=>'items'});
        }        
        
        #create child nodes
        my $i=0;
        my %h;
        for my $item_struct (@{$itemlist}) {
            my $ix=$item_struct->fbl('ItemId');
            my $itemid=$item_struct->{Fields}[$ix]{Value};
            my $item_strref=$twodas{items}[$itemid]{'STRREF_NAME'};
            my $item_name=string_from_resref($jade_path,$item_strref);
            my $item_type=$item_struct->{Fields}[$item_struct->fbl('Type')]{Value};
            
            my $data= { 'type'=>'2dalist',
                        '2daname' => 'items',
                        '2dafield' => 'STRREF_NAME',
                        'appendlabel' => 0,
                        'gff' => $item_struct->{Fields}[$ix],
                        'is_stringref'=>1,
                        'show_desc'=>1,
                        'descfield'=>'STRREF_DESC',
                        'filterfield'=>'TYPE',
                        'filtervalue'=>$itemtype_to_filter{$item_type}
                      };
            $h{$item_name.$i}=[$treeitem.'#ItemList_'.$itemtype_to_letter{$item_type}.'#'.$i,$item_name,$data];
            #add_new_treeitem($treeitem.'#ItemList_'.$itemtype_to_letter{$item_type}.'#'.$i,$item_name,$data);
            $i++;
        }
        for my $k (sort keys %h) {
            add_new_treeitem($h{$k}->[0],$h{$k}->[1],$h{$k}->[2]);
        }

    } #end item list...
    
    
    
    my $map_struct=$playercreature_struct->{Fields}[$playercreature_struct->fbl('Map')]{Value};
    my $available_style_points=0;
    my $style_points_ix;
    if (defined($style_points_ix=$map_struct->fbl('MapAvailablePoin'))) {
        $available_style_points=$map_struct->{Fields}[$style_points_ix]{Value};
    }
    else {
        $map_struct->createField('Type'=>FIELD_DWORD,'Label'=>'MapAvailablePoin','Value'=>0);
        $style_points_ix=$map_struct->fbl('MapAvailablePoin');
    }
    add_new_treeitem($treeitem.'#MapAvailablePoin',"Style Points Available: $available_style_points",$map_struct->{Fields}[$style_points_ix]);
    my $styles_list_arr_ref=$stats_struct->{Fields}[$stats_struct->fbl('Styles')]{Value};
    add_new_treeitem($treeitem.'#styles',"Styles",{'type'=>'addstyle', 'gff'=>$stats_struct->{Fields}[$stats_struct->fbl('Styles')],'2daname'=>'stylesuperlist'});
    
    
    #ok here's how the styles determine what they have for levelups...
    # first look at StyleId from the GFF struct
    # StyleId -> StyleSuperList.2da row
    # StyleSuperList.2da -> {field}[StyleData] row
    # StyleData.2da -> {field}[levelup2da] row
    # use 2da from above -> {field}[label] * this is a stringref for display eg. "Damage Increase"
    # also ->{field}[choice_1] through {field}[choice_5] -> StyleAdvance.2da row
    #  styleadvance.2da ->{field}[Parm1] is the adjustment made to the appropriate gff field...
    my %h;
    my $i;
    for ($i=0; $i<scalar @$styles_list_arr_ref; $i++) {
        my %style_data;
        my $style_struct=$$styles_list_arr_ref[$i];
        $style_data{'type'}='style';
        $style_data{'gff'}=$style_struct;
        get_style_data(\%style_data);
        $h{$style_data{'name'}.$i}=[$treeitem.'#styles#'.$i,$style_data{'name'},\%style_data];
        #add_new_treeitem($treeitem.'#styles#'.$i,$style_data{'name'},\%style_data);
    }
    for my $k (sort keys %h) {
        add_new_treeitem($h{$k}->[0],$h{$k}->[1],$h{$k}->[2]);
    }
            
        
}
sub read_sac {
    my $sac_path=shift;
    (open my $sac_fh,"<",$sac_path) or ( msg ("Could not open $sac_path","Read failed") && return);
    sysread $sac_fh,(my $num_of_gffs),4;
    $num_of_gffs=unpack('V',$num_of_gffs);
    
    for (my $i=1; $i<=$num_of_gffs; $i++) {
        sysread $sac_fh,(my $filename_length),4;
        $filename_length=unpack('V',$filename_length);
        sysread $sac_fh,(my $filename),$filename_length;
        $filename=unpack('Z*',$filename);
        sysread $sac_fh,(my $gff_length),4;
        $gff_length=unpack('V',$gff_length);
        sysread $sac_fh,(my $data),$gff_length;
        
        if ($i==$num_of_gffs) {
            close $sac_fh;
            my $gff=Bioware::GFF->new();
            $gff->read_gff_scalar(\$data);
            return $gff;
        }
    }
    close $sac_fh;
    return;
}
sub tree_NodeClick {
    my $node=shift;
    my $nodepath=$tree_nodes_to_paths{$node};
    my %nodeinfo=$mw->tree->GetItem($node);
    my $display_label=$nodeinfo{-text};
    LogIt("$nodepath clicked ($display_label)");
 
    my $data=$tree_data{$nodepath};
    if ($nodepath=~/styles#./) {
        ShowStyles();
    }
    else {
        HideStyles();
    }
    $mw->txtDesc->Hide();
    
    
    #initialize/clear controls
    $mw->btnApply->Enable(0);
    $mw->btnApply->Text('Apply');
    $mw->txtValue->Change(-text=>'');
    $mw->txtDesc->Change(-text=>'');
    $mw->lblValue->Change(-text=>'');
    $mw->txtDesc->Hide();
    $mw->lstValues->Hide();
    for my $ix(0..7) {
        $mw->{"opt$ix"}->Hide();
        $mw->{"opt$ix"}->SetCheck(0);
    }

    
    #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # simple numeric/string field
    #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    if ((ref $data) eq 'Bioware::GFF::Field') {
        $mw->lblValue->Change(-text=>$display_label);
        $mw->lblValue->Change(-pos=>$lblPos1);
        $mw->txtValue->Show();
        $mw->lstValues->Hide();
        $mw->txtDesc->Hide();
        $mw->txtValue->Change(-text=>$data->{Value});
        $mw->btnApply->Enable(1);
    }
    #~~~~~~~~~~~~~~~~~~~~~~~~~
    # something more complex
    #~~~~~~~~~~~~~~~~~~~~~~~~~
    elsif((ref $data) eq 'HASH') {
        
        #~~~~~~~~~~~~~
        # Style node
        #~~~~~~~~~~~~~
        if ($data->{type} eq 'style') {
            for my $slider_name qw(Slider0 Slider1 Slider2) {
                my $lblname=$data->{$slider_name}{'labelname'};
                $mw->$lblname->Text($data->{$slider_name}{'labelvalue'});
                $mw->$slider_name->SetPos($data->{$slider_name}{value});
                $mw->btnRemove->Enable(1);
            }
        }

        #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        # Internal lists, eg. Henchmen
        #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        if ($data->{type} eq 'list') {
            $mw->txtValue->Hide();
            $mw->lstValues->Show();
            $mw->lstValues->ResetContent();
          #  $mw->txtDesc->Show();
            $mw->lblValue->Change(-pos=>$lblPos2);
            $mw->lblValue->Change(-text=>$display_label);
            for my $listitem (@{$data->{list}}) {
                $mw->lstValues->AddString($listitem);
            }
            $mw->lstValues->SetCurSel($data->{gff}{Value});
            $mw->btnApply->Enable(1);
        }
        
        #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        # Option lists
        #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        if ($data->{type} eq 'optionlist') {
            $mw->txtValue->Hide();
            $mw->lstValues->Hide();
            $mw->lblValue->Change(-pos=>$lblPos2);
            $mw->lblValue->Change(-text=>$display_label);
            #show option buttons
            my $ix=0;
            for my $opt(@{$data->{options}}){
                my $optname="opt$ix";
                $mw->$optname->Show();
                $mw->$optname->Text($opt);
                $mw->{'opt'.$data->{gff}{Value}}->SetCheck(0);
                $ix++;
            }
            $mw->{'opt'.$data->{gff}{Value}}->SetCheck();
            $mw->btnApply->Enable(1);
        }
        #~~~~~~~~~~~~~~~~~~~~~~~~~~
        # Item or Gem Parent Node
        #~~~~~~~~~~~~~~~~~~~~~~~~~~
        if (($data->{type} eq 'additem')||($data->{type} eq 'addgem')) {
            $mw->txtValue->Hide();
            $mw->lstValues->Show();
            $mw->lstValues->ResetContent();
            $mw->txtDesc->Show();
            $mw->lblValue->Change(-pos=>$lblPos2);
            $mw->lblValue->Text("Available ".$itemtype_to_display{$data->{filtertype}});
            
            #we need to determine what items the PC does not have (except for gems), and populate the list accordingly
            my %itemids_present;
            if ($data->{type} eq 'addgem'){
            #    for my $struct (@{$data->{gff}{Value}}) {
            #        my $substruct=$struct->{Fields}{Value};
            #        $itemids_present{$substruct->{Fields}[$substruct->fbl('ItemID')]{Value}}=1;
            #    }
            }
            else {
                for my $item (@{$data->{gff}{Value}}) {
                    $itemids_present{$item->{Fields}[$item->fbl('ItemId')]{Value}}=1;
                }
            }
            
            my %available_itemids;
            for my $item(@{$twodas{items}}) {
                next if (exists $itemids_present{$item->{row}});
                next if ($item->{TYPE} ne $itemtype_to_filter{$data->{filtertype}});
                my $item_name_strref=$item->{STRREF_NAME};
                next if ($item_name_strref eq '****');
                my $item_desc_strref=$item->{STRREF_DESC};
                my $item_name=string_from_resref($jade_path,$item_name_strref);
                my $item_desc=string_from_resref($jade_path,$item_desc_strref);
                $available_itemids{$item_name.$item->{row}}{'2darow'}=$item->{row};
                $available_itemids{$item_name.$item->{row}}{'2daval'}=$item_name;
                $available_itemids{$item_name.$item->{row}}{'2dadesc'}=$item_desc;
            }
            my %lstrow_to_2darow;
            my $lst_ix=0;
            for my $key (sort keys %available_itemids) {
                my $val=$available_itemids{$key}{'2daval'};
                $mw->lstValues->AddString($val);
                $lstrow_to_2darow{$lst_ix}=$available_itemids{$key};
                $lst_ix++;
            }
            $data->{lstrow_to_2darow}=\%lstrow_to_2darow;
            $tree_data{$nodepath}=$data;
            $mw->btnApply->Text("Add Item");
            $mw->btnApply->Enable(1);
                
        }
        
        #~~~~~~~~~~~~~~~~~~~~
        # Style Parent Node
        #~~~~~~~~~~~~~~~~~~~~

        if ($data->{type} eq 'addstyle') {
            $mw->txtValue->Hide();
            $mw->lstValues->Show();
            $mw->lstValues->ResetContent();
            $mw->txtDesc->Show();
            $mw->lblValue->Change(-pos=>$lblPos2);
            $mw->lblValue->Text("Available Styles");
            #we need to determine what styles the PC does not have, and populate the list accordingly
            my $style_arr_ref;
            $style_arr_ref=$data->{gff}{Value};

            my %styleids_present;
            for my $style (@$style_arr_ref) {
                $styleids_present{$style->{Fields}[$style->fbl('StyleId')]{Value}}=1;
            }
            my %available_styleids;
            for my $style (@{$twodas{stylesuperlist}}) {
                if ($style->{NameRef} ne '****') {
                    if (! exists $styleids_present{$style->{row}}) {
                        my $style_name_strref=$style->{NameRef};
                        my $style_desc_strref=$style->{DescRef};
                        my $style_name=string_from_resref($jade_path,$style_name_strref);
                        my $style_desc=string_from_resref($jade_path,$style_desc_strref);
                        $available_styleids{$style_name.$style->{row}}{'2darow'}=$style->{row};
                        $available_styleids{$style_name.$style->{row}}{'2daval'}=$style_name;
                        $available_styleids{$style_name.$style->{row}}{'2dadesc'}=$style_desc;
                    }
                }
            }
            my %lstrow_to_2darow;
            my $lst_ix=0;
            for my $key (sort keys %available_styleids) {
                my $val=$available_styleids{$key}{'2daval'};
                $mw->lstValues->AddString($val);
                $lstrow_to_2darow{$lst_ix}=$available_styleids{$key};
                $lst_ix++;
            }
            $data->{lstrow_to_2darow}=\%lstrow_to_2darow;
            $tree_data{$nodepath}=$data;
            $mw->btnApply->Text("Add Style");
            $mw->btnApply->Enable(1);
            
        }
        
        #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        # Gem or Item Node or Some other listbox selection
        #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

        elsif ($data->{type} eq '2dalist') {
            $mw->txtValue->Hide();
            $mw->lstValues->Show();
            $mw->lblValue->Change(-pos=>$lblPos2);
            $mw->lblValue->Change(-text=>$display_label);
            $mw->lstValues->ResetContent();
            $mw->txtDesc->Show()  if $data->{show_desc};
            
            my $twodaname=$data->{'2daname'};
            my $twodafield=$data->{'2dafield'};
            #we want to alphabetize by 2davalue but we need to preserve 2darow information
            #there is also a chance that two 2darows will have the same 2davalue so we need to preserve uniqueness
            # our hash key will be concatenation of 2davalue & 2darow and our value will be a secondary hash
            # the secondary hash have the 2darow and the 2davalue
            my %rowvalue_info;
            for (my $row=0;$row<scalar@{$twodas{$twodaname}};$row++) {
                if ($data->{filterfield}) {
                    next unless  ($twodas{$twodaname}[$row]{$data->{filterfield}} eq $data->{filtervalue});
                }
                my $val=$twodas{$twodaname}[$row]{$twodafield};
                if ($data->{is_stringref}) {
                    next if $val eq '****';
                    $val = string_from_resref($jade_path,$val);
                }
                if ($data->{appendlabel}) {
                    $val.= ' ['.$twodas{$twodaname}[$row]{'Label'}.']';
                }

                
                $rowvalue_info{$val.$row}{'2darow'}=$row;
                $rowvalue_info{$val.$row}{'2daval'}=$val;
            }
            #my @rows = sort keys %{$rowvalue_info};
            my %lstrow_to_2darow;
            my $lst_ix=0;
            
            my $current_value;
            if ($data->{gff_is_list}) {# for gems we have to dig one more layer in...
                my $current_struct=$data->{gff}{Value}[$data->{gff_list_ix}];
                if ((ref $current_struct->{Fields}) eq 'Bioware::GFF::Field') {
                    my $current_substruct=$current_struct->{Fields}{Value};
                    $current_value=$current_substruct->{Fields}[$current_substruct->fbl('ItemID')]{Value};
                }
                
            }
            elsif ((ref $data->{gff}) eq 'Bioware::GFF::Field') {
                $current_value=$data->{gff}{Value};
            }
            #elsif ((ref $data->{gff}) eq 'Bioware::GFF::Struct') { 
            #    $current_value=$data->{gff}{Fields}{Value}{Fields}[$data->{gff}{Fields}{Value}->fbl('ItemID')]{Value};
            #}
            for my $row (sort keys %{rowvalue_info}) {
                next unless (defined $rowvalue_info{$row}{'2daval'});
                $mw->lstValues->AddString($rowvalue_info{$row}{'2daval'});
                $lstrow_to_2darow{$lst_ix}=$rowvalue_info{$row}{'2darow'};
                $lst_ix++;
            }
            $data->{lstrow_to_2darow}=\%lstrow_to_2darow;
            $tree_data{$nodepath}=$data;
            my %lstrow_from_2darow=reverse %lstrow_to_2darow;
            
            $mw->lstValues->SetCurSel($lstrow_from_2darow{$current_value});
            
            $global_suppress_next_logit=1;
            lstValues_SelChange();
            
            $mw->btnApply->Enable(1);
            $mw->btnRemove->Enable(1);
        }
    }
    
    #has this game been modified?
    my $game_nodepath='#'.(split /#/,$nodepath)[1];
    my $game_node=$tree_paths_to_nodes{$game_nodepath};
    my %game_nodeinfo=$mw->tree->GetItem($game_node);
    my $game_node_text=$game_nodeinfo{-text};
    #enable/disable save button
    if ($game_node_text =~ /\*$/) {
        $mw->btnSave->Enable(1);
    }
    else {
        $mw->btnSave->Enable(0);
    }
}
sub btnApply_Click() {
    my $node=$mw->tree->GetSelection();
    my $nodepath=$tree_nodes_to_paths{$node};
    #update gff field
    my $data=$tree_data{$nodepath};
    if ((ref $data) eq 'Bioware::GFF::Field') {
        LogIt("Apply: ".$mw->lblValue->Text()." $data->{Value} ->".$mw->txtValue->Text()); 
        $data->{Value}=$mw->txtValue->Text();
        #update node
        my %this_nodeinfo=$mw->tree->GetItem($node);
        my $this_node_text=$this_nodeinfo{-text};
        if ($this_node_text=~/(.*):/) {
            $this_node_text=$1.": ".$mw->txtValue->Text();
        }
        else {
            $this_node_text=$mw->txtValue->Text();
        }
        $this_nodeinfo{-text}=$this_node_text;
        $mw->tree->SetItem($node,%this_nodeinfo);
        
        #update game node 
        show_asterisk($nodepath);
    }
    elsif ((ref $data) eq 'HASH') {
        if ($data->{type} eq 'list') {
            #update node
            my %this_nodeinfo=$mw->tree->GetItem($node);
            my $this_node_text=$this_nodeinfo{-text};
            if ($this_node_text=~/(.*): (.*)/ ) {
                my $old_name=$1;
                my $old_value=$2;
                LogIt("Apply: $old_name $old_value -> ".$mw->lstValues->GetText($mw->lstValues->GetCurSel()));
                $this_node_text=$old_name.": ".$mw->lstValues->GetText($mw->lstValues->GetCurSel());
            }
            else {
                my $parent=$mw->tree->GetParent($node);
                my %parent_info=$mw->tree->GetItem($parent);
                my $parent_text=$parent_info{-text};
                LogIt("Apply: $parent_text $this_node_text -> ".$mw->lstValues->GetText($mw->lstValues->GetCurSel()));
                $this_node_text=$mw->lstValues->GetText($mw->lstValues->GetCurSel());
            }
            $this_nodeinfo{-text}=$this_node_text;
            $mw->tree->SetItem($node,%this_nodeinfo);
            #update parent
            show_asterisk($nodepath);            

            #update gff
            $data->{gff}{Value}=$mw->lstValues->GetCurSel();

        }
        if ($data->{type} eq 'optionlist') {
            #update node
            my %this_nodeinfo=$mw->tree->GetItem($node);
            my $this_node_text=$this_nodeinfo{-text};
            my $cursel=-1;
            for my $optix(0..7) {
                my $optname="opt$optix";
                if ($mw->$optname->GetCheck()) {
                    $cursel=$optix;
                }
            }
            return if $cursel==-1;
            
            if ($this_node_text=~/(.*): (.*)/ ) {
                my $old_name=$1;
                my $old_value=$2;
                LogIt("Apply: $old_name $old_value -> ".$mw->{"opt$cursel"}->Text());
                $this_node_text=$old_name.": ".$mw->{"opt$cursel"}->Text();
            }
            else {
                my $parent=$mw->tree->GetParent($node);
                my %parent_info=$mw->tree->GetItem($parent);
                my $parent_text=$parent_info{-text};
                LogIt("Apply: $parent_text $this_node_text -> ".$mw->{"opt$cursel"}->Text());
                $this_node_text=$mw->{"opt$cursel"}->Text();
            }
            $this_nodeinfo{-text}=$this_node_text;
            $mw->tree->SetItem($node,%this_nodeinfo);
            
            #update parent
            show_asterisk($nodepath);            
            #update gff
            $data->{gff}{Value}=$cursel;
            
        }
        
        
        if ($data->{type} eq '2dalist') {
            #update node
            my %this_nodeinfo=$mw->tree->GetItem($node);
            my $this_node_text=$this_nodeinfo{-text};
            if ($this_node_text=~/(.*): (.*)/ ) {
                my $old_name=$1;
                my $old_value=$2;
                LogIt("Apply: $old_name $old_value -> ".$mw->lstValues->GetText($mw->lstValues->GetCurSel()));
                $this_node_text=$old_name.": ".$mw->lstValues->GetText($mw->lstValues->GetCurSel());
            }
            else {
                my $parent=$mw->tree->GetParent($node);
                my %parent_info=$mw->tree->GetItem($parent);
                my $parent_text=$parent_info{-text};
                LogIt("Apply: $parent_text $this_node_text -> ".$mw->lstValues->GetText($mw->lstValues->GetCurSel()));
                $this_node_text=$mw->lstValues->GetText($mw->lstValues->GetCurSel());
            }
            
            $this_nodeinfo{-text}=$this_node_text;
            $mw->tree->SetItem($node,%this_nodeinfo);
            
            #update parent
            show_asterisk($nodepath);            

            #update gff
            if ($data->{gff_is_list}) {
                $data->{gff}{Value}[$data->{gff_list_ix}]=create_new_gem($data->{lstrow_to_2darow}{$mw->lstValues->GetCurSel()});
                #$data->{gff}=create_new_gem($data->{lstrow_to_2darow}{$mw->lstValues->GetCurSel()});
            }
            else {
                $data->{gff}{Value}=$data->{lstrow_to_2darow}{$mw->lstValues->GetCurSel()};
            }
            if (exists $data->{gff2}) {
                $data->{gff2}{Value}=$data->{lstrow_to_2darow}{$mw->lstValues->GetCurSel()};
            }
        }
        elsif($data->{type} eq 'style') {
            my $new_bit_string0='0' x 32;
            my $new_bit_string;
            my $new_stylevalue;
            for my $slider_name qw(Slider0 Slider1 Slider2) {
                my $bit_chunk='00000';
                my $bitty;
                my $slider_value=$mw->$slider_name->GetPos();
                
                LogIt("Apply: $data->{name} $data->{$slider_name}{'labelvalue'} $data->{$slider_name}{value} -> $slider_value");
                $data->{$slider_name}{value}=$slider_value;
                $new_stylevalue+=$slider_value;
                my $new_field_value=$data->{$slider_name}{baseline} + $data->{$slider_name}{adjustment_by_level}{$slider_value};
                
                my $field_name=$data->{$slider_name}{gff_field};
                if (defined(my $field_ix=$data->{gff}->fbl($field_name))) {
                    $data->{gff}{Fields}[$field_ix]{Value}=$new_field_value;
                }
                else {
                    $data->{gff}->createField('Type'=>FIELD_FLOAT,'Label'=>$field_name,'Value'=>$new_field_value);
                }
                
                for my $ix (1..$slider_value) {
                    $bitty .='1';
                }
                substr($bit_chunk,0,length($bitty),$bitty);
                $new_bit_string.=$bit_chunk;
            }
            $new_stylevalue+=1;  #why? I dunno. Bioware is funny
            substr($new_bit_string0,0,length($new_bit_string),$new_bit_string);
            LogIt("Apply: Style level for $data->{name} is now $new_stylevalue");
            if (defined(my $style_level_ix=$data->{gff}->fbl('StyleLevel'))) {
                $data->{gff}{Fields}[$style_level_ix]{Value}=$new_stylevalue;
            }
            else {
                $data->{gff}->createField('Type'=>FIELD_BYTE,'Label'=>'StyleLevel','Value'=>$new_stylevalue);
            }
            
            if (defined(my $style_level_info_ix=$data->{gff}->fbl('StyleLevelInfo'))) {
                $data->{gff}{Fields}[$style_level_info_ix]{Value}=unpack('V',pack('b*',$new_bit_string0));
            }
            else {
                $data->{gff}->createField('Type'=>FIELD_DWORD64,'Label'=>'StyleLevelInfo','Value'=>unpack('V',pack('b*',$new_bit_string0)));
            }
            #update parent
            show_asterisk($nodepath);
        }
        elsif ($data->{type} eq 'additem') {
            
            my $item_id=$data->{lstrow_to_2darow}{$mw->lstValues->GetCurSel()}{'2darow'};
            my $item_name=$data->{lstrow_to_2darow}{$mw->lstValues->GetCurSel()}{'2daval'};
            my %itemtype_from_filter=reverse %itemtype_to_filter;
            my $item_type=$itemtype_from_filter{ $twodas{items}[$data->{lstrow_to_2darow}{$mw->lstValues->GetCurSel()}{'2darow'}]{TYPE} };
            my $new_item_struct=create_new_item($item_id,$item_type);
            my $new_ix=scalar @{$data->{gff}{Value}};
            push @{$data->{gff}{Value}},$new_item_struct;
            #$data->{gff}{Value}=$item_arr_ref;
            
            my $new_item_data={
                       'type'=>'2dalist',
                        '2daname' => 'items',
                        '2dafield' => 'STRREF_NAME',
                        'appendlabel' => 0,
                        'gff' => $new_item_struct,
                        'is_stringref'=>1,
                        'show_desc'=>1,
                        'descfield'=>'STRREF_DESC',
                        'filterfield'=>'TYPE',
                        'filtervalue'=>$itemtype_to_filter{$item_type}
                      };
            my $n = $mw->tree->GetChild($node);
            my $npath;
            my $n_ix_max=0;
            while ($n) {
                $npath=$tree_nodes_to_paths{$n};
                $npath=~/(\d+)$/;
                $n_ix_max = $1 if ($1 > $n_ix_max);
                $n=$mw->tree->GetNextSibling($n);
            }
            add_new_treeitem($nodepath.'#'.($n_ix_max+1),$item_name,$new_item_data);
            LogIt("Add Item: $item_name ".$nodepath.'#'.($n_ix_max+1));
            show_asterisk($nodepath);
        }
        elsif ($data->{type} eq 'addgem') {
            #get the item id and name selected based on the listbox index
            my $item_id=$data->{lstrow_to_2darow}{$mw->lstValues->GetCurSel()}{'2darow'};
            my $item_name=$data->{lstrow_to_2darow}{$mw->lstValues->GetCurSel()}{'2daval'};
            my $new_gem=create_new_gem($item_id);
            my $new_ix=scalar @{$data->{gff}{Value}};
            push @{$data->{gff}{Value}},$new_gem;  #gem has been added to the list
            
            my $new_item_data= { 'type'=>'2dalist',
                        '2daname' => 'items',
                        '2dafield' => 'STRREF_NAME',
                        'appendlabel' => 0,
                        'gff' => $new_gem,
                        'is_stringref'=>1,
                        'show_desc'=>1,
                        'descfield'=>'STRREF_DESC',
                        'filterfield'=>'TYPE',
                        'filtervalue'=>'gems'
                      };
            
            
            
            my $n = $mw->tree->GetChild($node);
            my $npath;
            my $n_ix_max=0;
            while ($n) {
                $npath=$tree_nodes_to_paths{$n};
                $npath=~/(\d+)$/;
                $n_ix_max = $1 if ($1 > $n_ix_max);
                $n=$mw->tree->GetNextSibling($n);
            }
            add_new_treeitem($nodepath.'#'.($n_ix_max+1),$item_name,$new_item_data);
            LogIt("Add Item: $item_name ".$nodepath.'#'.($n_ix_max+1));
            show_asterisk($nodepath);
        }

        elsif ($data->{type} eq 'addstyle') {
            
            my $style_id=$data->{lstrow_to_2darow}{$mw->lstValues->GetCurSel()}{'2darow'};
            my $new_style_struct=create_new_style($style_id);
            
            push @{$data->{gff}{Value}},$new_style_struct;
            
            
            my %style_data;
            #my $style_struct=$$styles_list_arr_ref[$i];
            $style_data{'type'}='style';
            $style_data{'gff'}=$new_style_struct;
            get_style_data(\%style_data);
            
            my $n = $mw->tree->GetChild($node);
            my $npath;
            my $n_ix_max=0;
            while ($n) {
                $npath=$tree_nodes_to_paths{$n};
                $npath=~/(\d+)$/;
                $n_ix_max = $1 if ($1 > $n_ix_max);
                $n=$mw->tree->GetNextSibling($n);
            }
            add_new_treeitem($nodepath.'#'.($n_ix_max+1),$style_data{'name'},\%style_data);
            LogIt("Add Style: $style_data{'name'} ". $nodepath.'#'.($n_ix_max+1));
            show_asterisk($nodepath);
        }

    }
    #click node again
    tree_NodeClick($node);
    $mw->Redraw(1);
}
sub btnSave_Click() {
    my $node=$mw->tree->GetSelection();
    my $nodepath=$tree_nodes_to_paths{$node};
    my $gamedir=(split /#/,$nodepath)[1];
    my $game_nodepath='#'.$gamedir;
    my $game_gff=$tree_data{$game_nodepath};
    if (my $retn=write_sac("$jade_path\\save\\$gamedir",$game_gff)) {
        LogIt("Save results:");
        if ($retn==100) {
            msg("$jade_path\\save\\$gamedir\r\nBackup: OK\r\nUpdate: NOT SAVED","Write complete");
            LogIt("  Backup: OK");
            LogIt("  Update: NOT SAVED");
        }
        if ($retn>100) {
            msg("$jade_path\\save\\$gamedir\r\nBackup: OK\r\nUpdate: SAVE OK","Write complete");
            LogIt("  Backup: OK");
            LogIt("  Update: SAVE OK");

        }
        if ($retn<100) {
            msg("$jade_path\\save\\$gamedir\r\nBackup: NO\r\nUpdate: SAVE OK","Write complete");
            LogIt("  Backup: NO");
            LogIt("  Update: SAVE OK");
        }
        my $game_node=$tree_paths_to_nodes{$game_nodepath};
        my %game_nodeinfo=$mw->tree->GetItem($game_node);
        $game_nodeinfo{-text} =~ s/\*$//;
        $mw->tree->SetItem($game_node,%game_nodeinfo);
    }
    else {
        msg("$jade_path\\save\\$gamedir\r\nBackup: NO\r\nUpdate: NOT SAVED","Write incomplete",0,0x30);
        LogIt("  Backup: NO");
        LogIt("  Update: NOT SAVED");
    }
    tree_NodeClick($node);
}
sub write_sac {
    my $sac_directory=shift;
    my $game_gff=shift;
    my $save_sav_data=$game_gff->as_scalar();
    my $sac="$sac_directory\\save.sac";
    use bytes;
    my $save_sav_size=bytes::length $save_sav_data;
    my $sac_fh;
    my $backupresult=Win32::FileOp::CopyConfirm($sac => "$sac_directory\\Backup of save.sac");
    my $return_value;
    if ($backupresult) {
        LogIt("$sac backed up to ".'"Backup of save.sac"');
        $return_value+=100;
    }
    if (!(open $sac_fh,"+<",$sac)) {
        msg("Could not open $sac_directory\\save.sac for writing","Write failed");
        LogIt("Could not open $sac_directory\\save.sac for writing");
        return $return_value;
    }
    binmode $sac_fh;
    sysseek $sac_fh,0,0;
    sysread $sac_fh,(my $num_of_gffs),4;
    $num_of_gffs=unpack('V',$num_of_gffs);
    for (my $i=1; $i<=$num_of_gffs; $i++) {
        if ($i==$num_of_gffs) {
            syswrite $sac_fh,pack('V',9),4;
            syswrite $sac_fh,"save.sav";
            syswrite $sac_fh,pack('C',0),1;
            syswrite $sac_fh,pack('V',$save_sav_size),4;
            syswrite $sac_fh,$save_sav_data,$save_sav_size;
            my $new_size=sysseek($sac_fh,0,1);
            truncate($sac_fh,$new_size);
            close $sac_fh;
            $return_value++;
            return $return_value;
        }
        sysread $sac_fh,(my $filename_length),4;
        $filename_length=unpack('V',$filename_length);
        sysseek $sac_fh,$filename_length,1;
        sysread $sac_fh,(my $gff_length),4;
        $gff_length=unpack('V',$gff_length);
        sysseek $sac_fh,$gff_length,1;
    }
    
    return $return_value;
}
sub initialize_2das{
    get2da('stylesuperlist.2da') or msg("Could not find stylesuperlist.2da");
    get2da('styledata.2da')      or msg("Could not find styledata.2da");
    get2da('styleadvance.2da')   or msg("Could not find styleadvance.2da");
    get2da('appearance.2da')     or msg("Could not find appearance.2da");
    get2da('gems.2da')           or msg("Could not find gems.2da");
    get2da('items.2da')          or msg("Could not find items.2da");
    #get2da('henchdefaultdata.2da')          or msg("Could not find henchdefaultdata.2da");
}
sub get2da {
    #this subroutine receives a 2da filename, attempts to read it, and stuff the hash into the %twodas hash
    #returns 1 if successful, 0 if not
    
    my $twoda_name=shift;
    my $twoda_name_with_ext=($twoda_name =~ /\.2da$/i) ? $twoda_name : "$twoda_name.2da";
    my $twoda_name_sans_ext=($twoda_name !~ /\.2da$/i) ? $twoda_name : substr($twoda_name,0,-4);
    
    my $twoda_reader=Bioware::TwoDA->new();
    if (-e "$jade_path\\override\\$twoda_name_with_ext") { # get it from override...
        LogIt ("Override: $twoda_name_with_ext");
        my $result=$twoda_reader->read2da_asarray("$jade_path\\override\\$twoda_name_with_ext");
        if ((ref $result) eq 'ARRAY') {
            $twodas{$twoda_name_sans_ext}=$result;
            return 1;
        }
        else {
            return 0;
        }
    }
    my $rim=Bioware::RIM->new();
    my $rim_result=$rim->read_rim("$jade_path\\data\\miniglobal-a.rim");
    if ($rim_result) {
        my $rim_ix=$rim->get_resource_id_by_name($twoda_name_with_ext);
        if (defined($rim_ix)) { # get it from miniglobal-a.rim
            LogIt ("miniglobal-a.rim: $twoda_name_with_ext");
            my $rim_read_result=$rim->load_rim_resource_by_index($rim_ix);
            if ($rim_read_result>0) {
                
                my $twoda_data=$rim->{resources}[$rim_ix]{res_data};
                my $result=$twoda_reader->read2da_asarray(\$twoda_data);
                if ((ref $result) eq 'ARRAY') {
                    $twodas{$twoda_name_sans_ext}=$result;
                    return 1;
                }
                else {
                    return 0;
                }
            }
            else {
                return 0;
            }
        }
    }
    $rim_result=$rim->read_rim("$jade_path\\data\\globalunload-a.rim");
    if ($rim_result) {
        my $rim_ix=$rim->get_resource_id_by_name($twoda_name_with_ext);
        if (defined($rim_ix)) { # get it from globalunload-a.rim
            LogIt("globalunload-a.rim: $twoda_name_with_ext");
            my $rim_read_result=$rim->load_rim_resource_by_index($rim_ix);
            
            if ($rim_read_result>0) {
                my $twoda_data=$rim->{resources}[$rim_ix]{res_data};
            
                my $result=$twoda_reader->read2da_asarray(\$twoda_data);
                if ((ref $result) eq 'ARRAY') {
                    $twodas{$twoda_name_sans_ext}=$result;
                    return 1;
                }
                else {
                    return 0;
                }
            }
            else {
                return 0;
            }
        }
    }
    return 0;
    
}
sub ShowStyles {
    #$mw->btnApply->Hide();
    #$mw->btnSave->Hide();
    $mw->lblValue->Hide();
    $mw->txtValue->Hide();
    $mw->lstValues->Hide();
    $mw->btnRemove->Enable(1);
    for my $i (0..2) {
        my $slidername="Slider$i";
        $mw->$slidername->Show();
        my $lblname="lblSlider$i";
        $mw->$lblname->Show();
        for my $j (0..5) {
            my $ticname="ticSlider$i$j";
            $mw->$ticname->Show();
            
        }
    }
}
sub HideStyles(){
    $mw->btnRemove->Enable(0);
    for my $i (0..2) {
        my $slidername="Slider$i";
        $mw->$slidername->Hide();
        my $lblname="lblSlider$i";
        $mw->$lblname->Hide();

        for my $j (0..5) {
            my $ticname="ticSlider$i$j";
            $mw->$ticname->Hide();
        }
    }

    #$mw->btnApply->Show();
    #$mw->btnSave->Show();
    $mw->lblValue->Show();
    $mw->txtValue->Show();
    #$mw->lstValues->Show();
    
}
sub Slider0_Scroll {
    $mw->btnApply->Enable(1);
}
sub Slider1_Scroll {
    $mw->btnApply->Enable(1);
}
sub Slider2_Scroll {
    $mw->btnApply->Enable(1);
}
sub get_style_data{
    #this subroutine receives the style_data hash reference that will be eventually stored in the tree_data hash
    # so that the sliders will represent what is in the gff
    # called by Populate_Level1
    my $style_data_hashref=shift;
    
    
    
    my $style_name_resref=$style_data_hashref->{gff}{Fields}[$style_data_hashref->{gff}->fbl('NameRef')]{Value};
    my $style_name=Bioware::TLK::string_from_resref($jade_path,$style_name_resref);
    $style_data_hashref->{'name'}=$style_name;
    
    my $style_id=$style_data_hashref->{gff}{Fields}[$style_data_hashref->{gff}->fbl('StyleId')]{Value};
    $style_data_hashref->{styleid}=$style_id;
    my $styledata_row=$twodas{stylesuperlist}[$style_id]{'StyleData'};
    my $levelup2da=$twodas{styledata}[$styledata_row]{'levelup2da'};
    if (!(exists $twodas{$levelup2da})) {
        get2da($levelup2da);
    }
    
    my @style_levels;
    if (defined(my $style_level_info_ix=$style_data_hashref->{gff}->fbl('StyleLevelInfo'))) {
        my $style_level_info=$style_data_hashref->{gff}{Fields}[$style_level_info_ix]{Value};
    # Here's what's going on in the next couple of lines
    #  get the value of the StyleLevelInfo field,
    #  pack into a long
    #  unpack it into a 32-bit bitstring
    #  read a 5-bit chunk
    #  pack that back into something, a long I guess
    #  then unpack the thing using the special %<number> checksum operator to sum the bits
    #  and finally push it into our levels array
        push @style_levels,unpack('%32b*',pack('b*',substr(unpack('b*',pack('V',$style_level_info)),0,5)));
        push @style_levels,unpack('%32b*',pack('b*',substr(unpack('b*',pack('V',$style_level_info)),5,5)));
        push @style_levels,unpack('%32b*',pack('b*',substr(unpack('b*',pack('V',$style_level_info)),10,5)));
    }
    else {
        push @style_levels,(0,0,0);
    }
    
    #my @style_levels=get_style_levels_from_gff($style_data_hashref->{gff},$levelup2da,$style_name);
    #my @lvkeys=@{$twodas{$levelup2da}};
    for my $i (0..$#{$twodas{$levelup2da}}) {
        my $lblname="lblSlider$i";
        my $slidername="Slider$i";
        my $lblresref=$twodas{$levelup2da}[$i]{'label'};
        $lblresref ||= $twodas{$levelup2da}[$i]{'Label'};
        my $lblvalue=string_from_resref($jade_path,$lblresref);
        $style_data_hashref->{$slidername}{'labelname'}=$lblname;
        $style_data_hashref->{$slidername}{'labelvalue'}=$lblvalue;
        $style_data_hashref->{$slidername}{'value'}=$style_levels[$i];
    }
    
    # now we also need to get
    #  gff field name affected
    #  basevalue (value for pips=0)
    #  increment values for each level ( an array )
    
    my %styleadvance_effect1_to_gff_field =qw(
        72   StyleHealthOpp
        84   ChiChMult
        81   SpeedMult
        69   StyleChiMod
        86   DurationMult
        70   StyleFocusMod
    );
    for (my $ix=0; $ix<scalar (@{$twodas{$levelup2da}}); $ix++) {
        my $row =$twodas{$levelup2da}[$ix];
        my $last_effect_id=-1;
        my $last_advancement_label='';
        $style_data_hashref->{"Slider".$ix}{adjustment_by_level}{'0'}=0;
        for my $col (1..5) {
            my $colname='choice_'.$col;
            my $adv_row=$row->{$colname};
            my $this_effect_id=$twodas{styleadvance}[$adv_row]{'Effect1'};
            my $this_advancement_label=$twodas{styleadvance}[$adv_row]{'Label'};
            if ($last_effect_id==-1) {
                $last_effect_id=$this_effect_id;
            }
            else {
                if ($last_effect_id != $this_effect_id) {
                    LogIt ("Weird style advancement detected:");
                    LogIt ("  $style_name level ".($col-1)." points to $last_advancement_label with Effect1 of $last_effect_id");
                    LogIt ("  but level $col points to $this_advancement_label with Effect1 of $this_effect_id");
                }
            }
            $last_advancement_label=$this_advancement_label;
            $style_data_hashref->{"Slider".$ix}{adjustment_by_level}{$col} = $style_data_hashref->{"Slider".$ix}{adjustment_by_level}{$col-1}
                                                                           + $twodas{styleadvance}[$adv_row]{'Param1'};
            
        }
        my $gff_value_in_this_style=1;  #this might need fixing later
        if (defined (my $gff_ix = $style_data_hashref->{gff}->fbl($styleadvance_effect1_to_gff_field{$last_effect_id})) ) {
            $gff_value_in_this_style = $style_data_hashref->{gff}->{Fields}[$gff_ix]{Value};
        }
        my $baseline_value=$gff_value_in_this_style - $style_data_hashref->{"Slider".$ix}{adjustment_by_level}{$style_levels[$ix]};
        $style_data_hashref->{"Slider".$ix}{baseline}=$baseline_value;
        $style_data_hashref->{"Slider".$ix}{gff_field}=$styleadvance_effect1_to_gff_field{$last_effect_id};
    
    }

}
sub lstValues_SelChange {
    my $new_index=$mw->lstValues->GetCurSel();
    my $new_itemtext=$mw->lstValues->GetText($new_index);
    
    my $node=$mw->tree->GetSelection();
    my $nodepath=$tree_nodes_to_paths{$node};
    my $data=$tree_data{$nodepath};
    
    my $twoda=$data->{'2daname'};
    my $twodarow=$data->{lstrow_to_2darow}{$new_index};
    if (( ref$twodarow) eq 'HASH') {
        $twodarow=$twodarow->{'2darow'};
    }
    LogIt("Listbox value selected: $new_itemtext ($twoda $twodarow)");
    if ((ref $data) eq 'HASH') {
        if ($data->{type} eq '2dalist') {
            if ($data->{show_desc}) {
                my $strref=$twodas{$data->{'2daname'}}[$data->{lstrow_to_2darow}{$new_index}]{$data->{'descfield'}};
                my $txt=string_from_resref($jade_path,$strref);
                $txt=~s/\n/\r\n/g;
                $txt=~s/\r\n\n/\r\n/g;
                $mw->txtDesc->Text($txt);
            }
        }
            
        
        elsif(($data->{type} eq 'addstyle')||($data->{type} eq 'additem')||($data->{type} eq 'addgem')) {
            my $txt=$data->{lstrow_to_2darow}{$new_index}{'2dadesc'};
            $txt=~s/\n/\r\n/g;
            $txt=~s/\r\n\n/\r\n/g;
            $mw->txtDesc->Text($txt);
        }
    }
}
sub create_new_style {
    my $style_id=shift;
    my $struct=Bioware::GFF::Struct->new();
    my $healrate=$twodas{stylesuperlist}[$style_id]{'HealRate'};
    my $nameref=$twodas{stylesuperlist}[$style_id]{'NameRef'};
    my $descref=$twodas{stylesuperlist}[$style_id]{'DescRef'};
    my $iconref=$twodas{stylesuperlist}[$style_id]{'IconRef'};
    
    $struct->createField('Type'=>4, 'Label'=>'StyleId',       'Value'=>$style_id);
    $struct->createField('Type'=>0, 'Label'=>'StyleLevel',    'Value'=>0);
    $struct->createField('Type'=>6, 'Label'=>'StyleLevelInfo','Value'=>0);
    $struct->createField('Type'=>10, 'Label'=>'VisualEffectNode','Value'=>'');
    $struct->createField('Type'=>8, 'Label'=>'HealSpeed','Value'=>$healrate);
    $struct->createField('Type'=>8, 'Label'=>'TimeSpentInStyle','Value'=>0);
    $struct->createField('Type'=>5, 'Label'=>'NameRef','Value'=>$nameref);
    $struct->createField('Type'=>5, 'Label'=>'DescRef','Value'=>$descref);
    $struct->createField('Type'=>10, 'Label'=>'IconRef','Value'=>$iconref);
    $struct->createField('Type'=>8, 'Label'=>'RangeMult','Value'=>1);
    $struct->createField('Type'=>8, 'Label'=>'AOEMult','Value'=>1);
    $struct->createField('Type'=>5, 'Label'=>'FirstLoad','Value'=>1);
    
    return $struct;

}
sub create_new_item {
    my $item_id=shift;
    my $type=shift;
    my $struct=Bioware::GFF::Struct->new();
    $struct->createField('Type'=>FIELD_WORD, 'Label'=>'ItemId', 'Value'=>$item_id);
    $struct->createField('Type'=>FIELD_BYTE, 'Label'=>'Type', 'Value'=>$type);
    $struct->createField('Type'=>FIELD_BYTE, 'Label'=>'Count', 'Value'=>1);
    
    return $struct;
}
sub create_new_gem {
    my $item_id=shift;
    my $gem_struct=Bioware::GFF::Struct->new();
    my $gem_substruct=Bioware::GFF::Struct->new();
    my $gems_id=$twodas{items}[$item_id]{ID};
    my @effects_structs;
    for my $i(0..2) {
        my $effectid=$twodas{gems}[$gems_id]{'Effect'.$i};
        next if $effectid eq '****';
        my $effect_struct=Bioware::GFF::Struct->new();
        my $param  =$twodas{gems}[$gems_id]{'Parameter'.$i};
        my $duration=$twodas{gems}[$gems_id]{'Duration'.$i};

        $effect_struct->createField('Type'=>FIELD_DWORD, 'Label'=>'GemsEffectType',   'Value'=>$effectid);
        $effect_struct->createField('Type'=>FIELD_DWORD, 'Label'=>'GemsEffeectValue', 'Value'=>$param);
        $effect_struct->createField('Type'=>FIELD_DWORD, 'Label'=>'GemsEffectCurVal', 'Value'=>$param);
        $effect_struct->createField('Type'=>FIELD_FLOAT, 'Label'=>'GemsEffectDurati', 'Value'=>$duration);
        push @effects_structs,$effect_struct;
    }
    $gem_substruct->createField('Type'=>FIELD_WORD, 'Label'=>'ItemID', 'Value'=>$item_id);
    $gem_substruct->createField('Type'=>FIELD_LIST, 'Label'=>'GemsEffectList', 'Value'=>\@effects_structs);
    $gem_struct->createField('Type'=>FIELD_STRUCT,  'Label'=>'Gem', 'Value'=>$gem_substruct);
    return $gem_struct;
}
sub btnRemove_Click {
    my $node=$mw->tree->GetSelection();
    my $nodepath=$tree_nodes_to_paths{$node};
    my %nodeinfo=$mw->tree->GetItem($node);
    my $nodetext=$nodeinfo{-text};
    LogIt("Remove: $nodetext $nodepath");
    
    my $game_nodepath='#'.(split /#/,$nodepath)[1];
    my $game_node=$tree_paths_to_nodes{$game_nodepath};
    my $parent_node=$mw->tree->GetParent($node);
    my $parent_nodepath=$tree_nodes_to_paths{$parent_node};
    
    my $data=$tree_data{$nodepath};
    if ((ref $data) eq 'HASH') {
        if ($data->{type} eq '2dalist') { #items,gems
            if ((ref $data->{gff}) eq 'Bioware::GFF::Field') {  #the field is the key identifier for the Struct in the List to be removed
                my $field_label=$data->{gff}{Label};
                my $field_value=$data->{gff}{Value};
                my $parent_data=$tree_data{$parent_nodepath};
                my $struct_ref_arr=$parent_data->{gff}{Value};
                my @new_struct_array;
                for my $struct (@$struct_ref_arr) {
                    my $struct2=$struct;
                    if ((ref $struct->{Fields}) =~/Bioware/) {
                        $struct2=$struct->{Fields}{Value};
                    }
                    if ($struct2->{Fields}[$struct2->fbl($field_label)]{Value} ne $field_value) {
                        push @new_struct_array,$struct;
                    }
                    else {
                        $struct=$struct;
                    }
                }
                $parent_data->{gff}{Value}=\@new_struct_array;  # the struct has been removed
                show_asterisk($nodepath);
                $mw->tree->DeleteItem($node);                   # tree reflects change
                delete $tree_data{$nodepath};                   # data hash released
                delete $tree_nodes_to_paths{$node};             # path forgotten
                $mw->Redraw(1);
            }
        }
        elsif ($data->{type} eq 'style') {
            my $styleid=$data->{styleid};
            my $parent_data=$tree_data{$parent_nodepath};
            my $struct_ref_arr=$parent_data->{gff}{Value};
            my @new_struct_array;
            for my $struct (@$struct_ref_arr) {
                if ($struct->{Fields}[$struct->fbl('StyleId')]{Value} ne $styleid) {
                    push @new_struct_array,$struct;
                }
                else {
                    $struct=$struct;
                }
            }
            $parent_data->{gff}{Value}=\@new_struct_array; # the struct has been removed
            show_asterisk($nodepath);
            $mw->tree->DeleteItem($node);                   # tree reflects change
            delete $tree_data{$nodepath};                   # data hash released
            delete $tree_nodes_to_paths{$node};             # path forgotten
            $mw->Redraw(1);
        }
    }
    elsif ((ref $data) eq 'Bioware::GFF::Field'){
    # no op... we should only be removing structs
    }
}
sub show_asterisk {
    my $nodepath=shift;
    my $game_nodepath='#'.(split /#/,$nodepath)[1];
    my $game_node=$tree_paths_to_nodes{$game_nodepath};
    my %game_nodeinfo=$mw->tree->GetItem($game_node);
    my $game_node_text=$game_nodeinfo{-text};
    if ($game_node_text !~ /\*$/) {
        $game_node_text .='*';
    }
    $game_nodeinfo{-text}=$game_node_text;
    $mw->tree->SetItem($game_node,%game_nodeinfo);
    return;
}
